clear
clf
%
% somme de 2 sinusodes
%
nu1=0.1;
a1=1;
nu2=0.3;
a2=1;
%a2=0.01;
%
sigma_b=0.01;
%
nu_e=1;
T_e=1/nu_e;
T=50;
N=20000;
%
vec_t=(1:N)*T_e; % T_e=1
x1=a1*exp(2i*pi*nu1*vec_t);
x2=a2*exp(2i*pi*nu2*vec_t);
x=x1+x2+sigma_b*randn(size(x1));
rect=zeros(1,N);
t=1:T;
rect(t)=1;
f=(0:N-1)/N;
f=f-0.5;
%
clf
semilogy(f,fftshift(abs(fft(x.*rect))),'b','linewidth',2)
%
%return
W=zeros(1,N);
t=1:T;
W(t)=0.42+0.5*cos(2*pi*(t+T/2)/T)+0.08*cos(4*pi*(t+T/2)/T);
f=(0:N-1)/N;
f=f-0.5;
hold on
plot(f,fftshift(abs(fft(x.*W))),'r','linewidth',2)
%
plot([1 1]*nu1,get(gca,'ylim'),'k--','linewidth',2)
plot([1 1]*nu2,get(gca,'ylim'),'k--','linewidth',2)
set(gca,'xlim',[0 0.5])
%set(gca,'ylim',10.^[-6 2])
set(gca,'fontsize',18)
xlabel('frquence [Hz]')
L=legend('fentre rectangle','fentre de Blackman');
set(L,'location','southeast')
title(['|X_F(\nu)| pour A_1 = ' num2str(a1) ...
    ' et A_2 = ' num2str(a2)])
grid on
%set(gca,'xtick',[])