clear
%
step=4;
%
% image initiale convertie en N&B
load load_rossignol ima
s=ima;
S=fft2(s);
%
% bruit
B=gausswin(size(s,1))*gausswin(size(s,2))';
B=ifftshift(B.^200).*exp(1i*2*pi*rand(size(B)));
B=retard_entier(retard_entier(B,300).',500)';
b=real(ifft2(B));
b=b*sum(s(:).^2)/sum(b(:).^2);
%
% signal + bruit
x=s+b;
X=fft2(x);
%
figure(1);clf
subplot(2,3,1)
imagesc(s);axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('s_\lambda')
%
subplot(2,3,2)
imagesc(b);axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('x_\lambda = s_\lambda + b_\lambda')
%
if step==1
    return
end
%
F=ones(60);
DSP_S=filter2(F,fftshift(abs(S).^2));
DSP_X=filter2(F,fftshift(abs(X).^2));
%
subplot(2,3,5)
imagesc(log10(DSP_X));axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('\Gamma_{xx}')
h=colorbar;set(h,'location','southoutside');vec=caxis;
%
subplot(2,3,4)
imagesc(log10(DSP_S));axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('\Gamma_{ss}')
h=colorbar;set(h,'location','southoutside');caxis(vec)
%
if step==2
    return
end
%
% filtrage
%
M=max(abs(DSP_X(:)));
H=abs(DSP_X)>M/100;
H=imdilate(H,ones(300));
H=H==0;
%
y=real(ifft2(X.*ifftshift(H)));
%
Y=fft2(y);
DSP_Y=filter2(F,fftshift(abs(Y).^2));
%
subplot(2,3,6)
imagesc(log10(DSP_Y));axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('\Gamma_{yy}')
h=colorbar;set(h,'location','southoutside');caxis(vec)
%
if step==3
    return
end
%
subplot(2,3,3)
imagesc(y);axis image;colormap(pink);set(gca,'xtick',[]);set(gca,'ytick',[]);
set(gca,'fontsize',14);title('y_\lambda = conv(x_\lambda,h)')
