clear
clf
%
% Dans l'ordre, testez choix_sous_echantillonnage 0, puis 1
choix_sous_echantillonnage=0;   % 0 , puis 1
%
% Dans l'ordre, testez choix_anti_repliement 0, puis 1
choix_anti_repliement=0;
%
% ne pas modificer ce qui suit
%=============================
%
% liste des noms de fichiers
if choix_sous_echantillonnage==1
    %cell_nom={'e_mi_aigu'};
    cell_nom={'g_sol'};
else
    %cell_nom={'e_mi_grave','a_la','d_re','g_sol','b_si','e_mi_aigu'};
    cell_nom={'a_la','g_sol','e_mi_aigu'};
end
%
%choix_sous_echantillonnage=1;   % 0 , puis 1
%
if choix_sous_echantillonnage==0
    choix_anti_repliement=0;
end
%
xlim=[0 2000];
for c=1:length(cell_nom)
    % boucle sur chacun des fichiers
    nom=cell_nom{c};
    % ouverture du fichier
    [x,nu_e]=audioread([nom '.wav']);
    %
    T=4;
    %
    x=x(1:nu_e*T);
    % play
    sound(x,nu_e)
    % calcul de la TFD
    X=fft(x);
    % dfinition du vecteur des frquences
    N=length(x);
    delta_f=nu_e/N;
    t=(0:N-1)*1/nu_e;
    f=(0:N-1)*delta_f;
    %
    % trac
    subplot(length(cell_nom),2,1+2*(c-1))
    plot(t,x,'b')
    set(gca,'fontsize',14)
    set(gca,'xlim',[1 length(x)]/nu_e)
    xlabel('n T_e [s]')
    title('x_n')
    %
    subplot(length(cell_nom),2,2+2*(c-1))
    h=plot(f(1:end/2),20*log10(abs(X(1:end/2))/nu_e),'b');
    set(h,'linewidth',2)
    set(gca,'xlim',xlim)
    set(gca,'fontsize',14)
    %xlabel('k \Delta_\nu  [Hz]')
    xlabel('\nu  [Hz]')
    grid on
    %
    % on rcupre la partie positive du spectre
    XX=abs(X(1:end/2)).^2;
    %
    % on lisse XX
    F=zeros(size(XX));
    F(1:5)=1;
    F(end-3:end)=1;
    XXX=ifft(fft(XX).*fft(F));
    %
    % on seuil  0 les valeurs plus basses que 2% du maximum
    XXX(XXX<0.02*max(XXX))=0;
    %
    % recherche des maxima locaux
    [val_max,ind]=find_max_loc(XXX);
    f1=f(ind(1));
    %
    if choix_sous_echantillonnage==0
        ylim=get(gca,'ylim');
        hold on;plot(f1*[1 1],ylim,'r','linewidth',2)
        for n=2:30
            plot(f1*n*[1 1],ylim,'r--','linewidth',2)
        end
    end
    %
    %title(['|X_k|_{dB}, frquence principale = ' num2str(round(f1*10)/10) ' Hz'])
    title(['|X(\nu)|_{dB}, frquence principale = ' num2str(round(f1*10)/10) ' Hz'])
    %
    T=length(x)/nu_e;
    pause(T)
    %
end
%
if choix_sous_echantillonnage==1
    sous_echant=4;
    if choix_anti_repliement==0
        y=x;
    else
        [b,a]=cheby1(3,2,0.8/sous_echant);
        y=filtfilt(b,a,x);
    end
    %
    xx=y(1:sous_echant:end);
    nnu_e=nu_e/sous_echant;
    %
    sound(xx,nnu_e)
    %
    XX=fft(xx);
    % dfinition du vecteur des frquences
    NN=length(xx);
    ddelta_f=nnu_e/NN;
    tt=(0:NN-1)*1/nnu_e;
    ff=(0:NN-1)*ddelta_f;
    %
    % trac
    hold on
    plot(ff(1:end/2),20*log10(abs(XX(1:end/2))/nnu_e),'r')
    set(gca,'xlim',xlim)
    %
    L=legend(['chantillonn  ' num2str(nu_e/1000) ' kHz'],['chantillonn  ' num2str(nu_e/1000/sous_echant) ' kHz']);
    set(L,'Location','southeast')
end