%%% Generation d'un rectangle de largeur l et de hauteur h
%%% au centre d'un image de dimensions dim_x * dim_y
%%%
%%% usage : im=make_rect(l,h,dim_x,dim_y)
%%% Entree : 
%%% - l : longueur du rectangle
%%% - h : hauteur du rectangle
%%% - dim_x : largeur de l'image
%%% - dim_y : hauteur de l'image
%%% Sortie :
%%% - im : image de sortie
function im=make_rect(l,h,dim_x,dim_y)

im=zeros(dim_y,dim_x);
x_c=ceil(dim_x/2+1/2);
y_c=ceil(dim_y/2+1/2);
int_l = x_c-ceil(l/2-1/2):x_c+floor(l/2-1/2);
int_h = y_c-ceil(h/2-1/2):y_c+floor(h/2-1/2);
im(int_h,int_l) = 1/(l*h);
