clear
%
choix_signal=1;
choix_zero_padding=0;
%
if choix_signal==1
    N=128;
    g=gausswin(N,5);
    %
    x=[zeros(size(g));g;zeros(size(g)); ...
        zeros(size(g)); ...
        zeros(size(g));zeros(size(g))];
    %
    y=[zeros(size(g)); ...
        zeros(size(g));zeros(size(g));g; ...
        zeros(size(g));g];
    %
    y=y+0.25*randn(size(y));
elseif choix_signal==2
    N=128;
    g=gausswin(N,5);
    %
    x=[zeros(size(g));g;zeros(size(g)); ...
        zeros(size(g)); ...
        zeros(size(g));zeros(size(g))];
    %
    y=[g; ...
        zeros(size(g));zeros(size(g));g; ...
        zeros(size(g));g];
    %
    y=y+0.25*randn(size(y));
elseif choix_signal==3
    N=64;
    g=gausswin(N,3);
    %
    x=[g;zeros(size(g));zeros(size(g)); ...
        zeros(size(g)); ...
        zeros(size(g));g];
    %
    y=[g; ...
        zeros(size(g));g;g; ...
        zeros(size(g));g];
    %
    y=y+0.25*randn(size(y));
elseif choix_signal==4
    N=2^8;
    %
    Te=1;
    tau0=50;
    gamma0=1;
    %
    A=[tau0+Te -tau0];
    B=Te;
    %
    x=randn(N,1);
    y=sqrt(gamma0*2*tau0)*filter(B,A,x);
    %
elseif choix_signal==5
    N=32;
    g=rand(N,1)>0.5;
    g0=rand(N,1)>0.5;
    g1=rand(N,1)>0.5;
    g2=rand(N,1)>0.5;
    g3=rand(N,1)>0.5;
    g4=rand(N,1)>0.5;
    %
    x=[g;zeros(size(g));zeros(size(g)); ...
        zeros(size(g)); ...
        zeros(size(g));zeros(size(g))];
    %
    y=[g0; ...
        g1;g2;g3; ...
        g;g4];
    %
    y=y+0.025*randn(size(y));
end
%
if choix_signal<4
    ylim=[-1 2];
else
    ylim=[-2 2];
end
%
N=length(x);
%
figure(1)
clf
subplot(2,1,1)
h=plot(x,'r');set(h,'linewidth',2)
set(gca,'xlim',[1 N])
set(gca,'ylim',ylim)
set(gca,'fontsize',14)
grid on
title('x_n (signal emis)')
xlabel('n')
subplot(2,1,2)
plot(y)
set(gca,'xlim',[1 N])
set(gca,'ylim',[-1. 2])
set(gca,'fontsize',14)
grid on
title('y_n (signal recu)')
xlabel('n')

if choix_zero_padding==1
    x=[x;zeros(size(x))];
    y=[y;zeros(size(y))];
end
%
NN=length(x);
c=real(ifft(fft(y).*conj(fft(x))));
%
if choix_signal<4
    
    figure(2+choix_zero_padding)
    clf
    subplot(2,1,1)
    plot(y)
    hold on
    set(gca,'xlim',[1 NN])
    set(gca,'ylim',ylim)
    set(gca,'fontsize',14)
    grid on
    xlabel('j')
    %
    for n=1:N
        figure(2+choix_zero_padding)
        subplot(2,1,1)
        h=plot(retard_entier(x,n-1),'r');set(h,'linewidth',2)
        title(['en bleu y_j, en rouge x_j retarde de n = ' num2str(n-1)])
        subplot(2,1,2)
        plot(n-1,c(n),'xk')
        set(gca,'fontsize',14)
        grid on
        title('correlation calcule par fft : c_n=1/N\Sigma_k Y_k X_k^* e^{2 i pi k n/N}')
        xlabel('retard n')
        drawnow
        if n==1
            hold on
            pause(5)
            delete(h)
        elseif n<N
            pause(0.01);
            delete(h)
        end
    end
else
    figure(2)
    NN=100;
    if choix_zero_padding==1
        hold on
        plot(0:NN-1,c(1:NN),'r')
        legend('sans zero-padding','avec')
    else
        %clf;
        hold on
        plot(0:NN-1,c(1:NN))
        set(gca,'fontsize',14)
        grid on
        title('correlation calcule par fft : c_n=1/N\Sigma_k Y_k X_k^* e^{2 i pi k n/N}')
        xlabel('retard n')
    end
end