clear
clf
%
disp('on considre une sinusode  la frquence 1 kHz')
disp(' ')
% frquence de la sinusode
nu0=1000;% 1kHz
% dure de l'acquisition
T=0.02; % 20 ms
%
% frquence d'chantillonnage
%nu_e=input('frquence d''chantillonnage ? ');
nu_e=50000; % 50 kHz
%nu_e=10000; % 10 kHz
%nu_e=1100; % 1.1 kHz
%
Nu_e=10^5;
Te=1/Nu_e;
vec_t=Te:Te:T;
%
vec_x=cos(2*pi*nu0*vec_t+rand);
%
te=1/nu_e;
ti=rand*te;
vec_tt=ti:te:T;
vec_xx=cos(2*pi*nu0*vec_tt);
%
ylim=[-1 1];
for i=1:length(vec_t)
    t=vec_t(i);
    vec=abs(vec_tt-t);
    [~,ii]=min(vec);
    %
    clf
    subplot(2,1,1)
    plot(vec_t(1:i)*1000,vec_x(1:i))
    xlim=get(gca,'xlim');
    set(gca,'ylim',ylim);
    set(gca,'fontsize',14)
    title(['simulation d''un signal "analogique" sinusode  ' num2str(nu0/1000) ' kHz'])
    xlabel('temps [ms]')
    ylabel('x(t) [V]')
    grid on
    %
    subplot(2,1,2)
    plot(vec_tt(1:ii)*1000,vec_xx(1:ii),'x')
    set(gca,'xlim',xlim);
    set(gca,'ylim',ylim);
    set(gca,'fontsize',14)
    title(['signal "numrique" chantillonn  ' num2str(nu_e/1000) ' kHz'])
    xlabel('n T_e [ms]')
    ylabel('x_n = x(n T_e) [V]')
    grid on
    %
    drawnow
end