clear
%
% A : amplitude de la sinusode
%
A=10;
%
% nu : frquence de la sinusode
%
nu=50;
%
% taille de l'chantillon considr
%
N=100000;
%
% gnration de N phase distribues suivant une loi uniforme entre 0 et 2pi
%
phi=2*pi*rand(N,1);
%
% t corrrespond  un instant fix de manire alatoire
%
t=randn;
%
% gnration de N ralisation de la fonction alatoire x  l'instant t
%
x=A*cos(2*pi*nu*t+phi);
%
disp('simulation de N ralisations d''une sinusode')
%
% histogramme des valeurs de x  l'instant t
%
[b,a]=hist(x,100);
bar(a,b/sum(b))
set(gca,'fontsize',16)
%
disp(['moyenne empirique : ' num2str(mean(x))])
disp(['variance empirique : ' num2str(var(x))])